<?xml version="1.0"?>

<configuration>
 
  <property>
    <name>yarn.nodemanager.aux-services</name>
    <value>{{ yarn.nodemanager.aux_services.name }}</value>
  </property>

  <property>
    <name>yarn.nodemanager.aux-services.{{ yarn.nodemanager.aux_services.name }}.class</name>
    <value>{{ yarn.nodemanager.aux_services.class }}</value>
  </property>

  <property>
    <name>yarn.nodemanager.env-whitelist</name>
    <value>JAVA_HOME,HADOOP_COMMON_HOME,HADOOP_HDFS_HOME,HADOOP_CONF_DIR,CLASSPATH_PREPEND_DISTCACHE,HADOOP_YARN_HOME,HADOOP_HOME,PATH,LANG,TZ,HADOOP_MAPRED_HOME</value>
  </property>

  <!-- source: https://hadoop.apache.org/docs/current/hadoop-yarn/hadoop-yarn-site/ResourceManagerHA.html -->
  <property>
    <name>yarn.resourcemanager.ha.enabled</name>
    <value>{{ yarn.resourcemanager.ha.enabled }}</value>
  </property>

  <property>
    <name>yarn.resourcemanager.cluster-id</name>
    <value>{{ yarn.resourcemanager.cluster_id }}</value>
  </property>

  <property>
    <name>yarn.resourcemanager.ha.rm-ids</name>
    <!--expected values: <value>rm1,rm2</value>-->
    <value>{{ groups.resourcemanagers | map('extract', hostvars, 'resourcemanager_id') | list | join(',') }}</value>
  </property>

  {% for resourcemanager in groups.resourcemanagers %}
  <property>
    <name>yarn.resourcemanager.hostname.{{ hostvars[resourcemanager].resourcemanager_id }}</name>
    <value>{{ resourcemanager }}</value>
  </property>
  {% endfor %}

  {% for resourcemanager in groups.resourcemanagers %}
  <property>
    <name>yarn.resourcemanager.webapp.address.{{ hostvars[resourcemanager].resourcemanager_id }}</name>
    <value>{{ resourcemanager }}:8088</value>
  </property>
  {% endfor %}

  <property>
    <name>hadoop.zk.address</name>
    <!-- expected value: <value>zk1:2181,zk2:2181,zk3:2181</value> -->
    <value>{{ groups.zookeepers | map('regex_replace', '^(.*)$', '\\1:2181') | list | join(',') }}</value>
  </property>

</configuration>
